package com.gingersoft.gsa.cloud.table.mvp.contract;

import android.app.Activity;
import android.content.Intent;

import com.gingersoft.gsa.cloud.base.common.bean.BaseResult;
import com.gingersoft.gsa.cloud.table.mvp.model.bean.BaseRespose;
import com.gingersoft.gsa.cloud.table.mvp.model.bean.request.OrderRequest;
import com.jess.arms.base.DefaultAdapter;

import io.reactivex.Observable;
import okhttp3.RequestBody;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 01/09/2020 19:23
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
public interface OrderContentContract {
    //对于经常使用的关于UI的方法可以定义到IView中,如显示隐藏进度条,和显示文字消息
    interface View extends BaseOrderContract.View {

        void showChoosePeopleNumDialog(boolean isNeedCancel);

        void setTopFunctionAdapter(DefaultAdapter adapter);

        void setTopFunctionRecycleLayoutManager();

        void setFoodRecycleLayoutManager(int orientation);

        void setTopFunctionRecycleSpanCount(int size);

        void setFoodRecycleSpanCount(int size);

        void setTvWhole(double whole);

        void setTvTotal(double total);

        void printSuccess();

        void startActivityForResult(int Code, Class clazz, Intent intent);

        void sendSuccess();
    }

    //Model层定义接口,外部只需关心Model返回的数据,无需关心内部细节,即是否使用缓存
    interface Model extends BaseOrderContract.Model {

//        Observable<BaseResult> createOrder(RequestBody requestBody);
//
//        Observable<BaseResult> addFood(RequestBody requestBody);

        Observable<BaseRespose> printOrder(RequestBody request);
    }
}
